<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelInventoryDescription ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelInventoryDescription extends AbstractStructArrayBase
{
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelInventoryDescription[]
     */
    public $Description;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelInventoryDescription
     * @uses ArrayOfJPSOAP_HotelInventoryDescription::setDescription()
     * @param \StructType\JPSOAP_HotelInventoryDescription[] $description
     */
    public function __construct(array $description = array())
    {
        $this
            ->setDescription($description);
    }
    /**
     * Get Description value
     * @return \StructType\JPSOAP_HotelInventoryDescription[]|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelInventoryDescription[] $description
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventoryDescription
     */
    public function setDescription(array $description = array())
    {
        foreach ($description as $arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem instanceof \StructType\JPSOAP_HotelInventoryDescription) {
                throw new \InvalidArgumentException(sprintf('The Description property can only contain items of \StructType\JPSOAP_HotelInventoryDescription, "%s" given', is_object($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem) ? get_class($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem) : gettype($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem)), __LINE__);
            }
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Add item to Description value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelInventoryDescription $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventoryDescription
     */
    public function addToDescription(\StructType\JPSOAP_HotelInventoryDescription $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelInventoryDescription) {
            throw new \InvalidArgumentException(sprintf('The Description property can only contain items of \StructType\JPSOAP_HotelInventoryDescription, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Description[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Description
     */
    public function getAttributeName()
    {
        return 'Description';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventoryDescription
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
